class String
  def extractMeta
    self[/#{"\""}(.*?)#{"\""}/m, 1]
  end
end

def parseCollection searchColl
  $client.communities.all.each do |community|
    $client.communities.collections(:id => community.id).each do |collection|
      if((searchColl.gsub('_',' ') <=> collection.name) == 0)
        return(collection.id)
      end
    end
  end
  return(0)
end

def parseCommunity searchComm
  $client.communities.all.each do |community|
    #p "Nucleo: #{searchComm}"
    #p "Comunidade: #{community.name.split(" ")[0]}"
      if(searchComm == community.name.split(" ")[0])
        return(community.id)
    end
  end
  return(0)
end

def getName meta
  f = File.open(meta, "r")
  i = 0
  f.each_line{|line|
    if(i == 1)
      return(line.extractMeta)
    end
  i += 1
  }
end

def getDescription meta
  f = File.open(meta, "r")
  i = 0
  f.each_line{|line|
    if(i == 2)
      return(line.extractMeta)
    end
  i += 1
  }
end

def coleRec file, id
  g = Dir[file + "/*"].sort
  g.each{|file|
    target = file
    target = target.split('/')[-1].split("_")
    if(target[0] == "COL")
      #p "Colecao #{file.split('/')[-1]}"
      meta = file + "/" + file.split('/')[-1] +".metadata"
      name = getName(meta)
      description = getDescription(meta)
      #p "id: #{id}"
      coll = $client.communities.create_collection(
        Dspace::Collection.new(
          {
            'name' => name,
            'introductoryText' => description
          }
        ),
        id: id
      )
      id = parseCollection(name)
    end
    if(target[0] == "NUCLEO")
      #p "Nucleo #{file.split('/')[-1]}"

    end
    if(target[0] == "ITEM")
    #  p "Item #{file.split('/')[-1]}"
      meta = file + "/" + file.split('/')[-1] +".metadata"
      name = getName(meta)
      description = getDescription(meta)
    end

  }
end
###################################################################################################
$LOAD_PATH.unshift('/home/starosta/c3sl/seppir/scriptsRuby/rest-client-gem/lib')
#################################### A U T E N T I C A C A O ######################################
require 'dspace'
$client = Dspace::Client.new(dspace_api: 'https://seppirdev.c3sl.ufpr.br:8443/rest')
if !$client.is_running?
  raise 'Can\'t connect to DSpace API.'
end
$client.login 'admin@seppirdev.com', 'adminadmin'
#################################### C O L E C O E S ##############################################
root ='/home/starosta/c3sl/dspace-scripts/files/BANCO-SEPPIR-20160624/'

d = Dir[root + "*"].sort
d.each{|file|
  com = file
  com = com.split('/')[-1].split('_')
  if(com[0] == "NUCLEO")
    id = parseCommunity(com[1])
  end
  p id
  p com[1]
  coleRec(file,id)
}
